#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <dos.h>

typedef float t_weight;
typedef struct {
  int da_year;     /* current year */
  char da_day;     /* day of the month */
  char da_mon;     /* month (1 = Jan) */
} t_birthday;
typedef char *t_name ;
typedef struct
  { t_weight p_weight;
    t_birthday p_birthday;
    t_name p_name;
  } t_person;

t_person* init_person ( int weight, t_birthday birthday, char *name);
void kill_person(t_person* x);
void display_person(t_person* x);
char *dstring(t_birthday *date,char *ret);

void main()
{ t_person *Neil;
  t_birthday bday;
  bday.da_year=1962;
  bday.da_mon=4;
  bday.da_day=11;
  printf("bday address =%f\n",bday);
  Neil=init_person(130,bday,"Neil Chakrabarty");
  display_person(Neil);
  kill_person(Neil);
}

t_person* init_person ( int weight, t_birthday birthday, char *name)
{ t_person *new_person;
  new_person = (t_person *) malloc(sizeof(t_person));
  new_person->p_weight=weight;
  printf("before new_person->p_birthday address = %f\n",new_person->p_birthday);
  new_person->p_birthday=birthday;
  printf("after new_person->p_birthday address = %f\n",new_person->p_birthday);
  new_person->p_name=(char *) malloc(strlen(name));
  strcpy(new_person->p_name,name);
  return (new_person);
}
void display_person(t_person *x)
{ char* buff="           ";
	    //12345678901
  t_birthday *bday;
  printf("***** Person %s **********\n",x->p_name);
  printf("* Person Pointer  %x\n",&x);
  printf("* Name Pointer    %x\n",&x->p_name);
  printf("* Weight          %f\n",x->p_weight);
  printf("* Weight address  %x\n",&x->p_weight);
  printf("* Birthday pointer %x\n",&x->p_birthday);
  bday=&x->p_birthday;
  printf("* Birthday date    %s\n",dstring(bday,buff));
  printf("***************************************\n\n");
}
char *dstring(t_birthday *date,char *buf)
{ sprintf(buf,"%2d/%2d/%4d",date->da_mon,
			    date->da_day,
			    date->da_year);
  return buf;
}
void kill_person(t_person *x)
{ printf("***** Killing %s **********\n",x->p_name);
  free(x->p_name);
  free(x);
}